﻿// mainframe.as
/*
  Тут часть кода, работающая с основным окном
*/
#pragma once
#include "..\all.h"

void initWorkWithMainFrame()
{
    getEventService().subscribe(eventCreateFrame, AStoIUnknown(EventTopLevelFrame(), IID_IEventRecipient));
}

ITopLevelFrame&& mainFrame;
ITopLevelFrame&& coreMainFrame;

class EventTopLevelFrame
{
    void onEvent(const Guid&in eventID, long val, IUnknown& obj)
    {
        ITopLevelFrame&& frame = obj;
#if test = 1
        dumpVtable(&&frame, "_EventTopLevelFrame");
#endif
        if (frame !is null) {
            if (mainFrame is null) {
                if (frame.frameType() == eTLFT_Main) {
                    &&mainFrame = frame;
                    mainFrame.getCoreTopLevelFrame(coreMainFrame);
#if test = 1
                    IWindow&& wnd = cast<IUnknown>(mainFrame);
                    dumpVtable(&&wnd, "_MainFrame");
                    dumpVtable(&&coreMainFrame, "_CoreMainFrame");
#endif
                    trMainFrame_setTitle.setTrap(coreMainFrame, ITopLevelFrame_setTitle, MainFrame_setTitle);
                    trMainFrame_setAddTitle.setTrap(coreMainFrame, ITopLevelFrame_setAdditionalTitle, MainFrame_setAdditionalTitle);
                    // Создаем подписчика на уведомления о простое
                    getIdleService().addIdleHandler(AStoIUnknown(IdleHandler(), IID_IIdleHandler));
                    // Инициализируем пакеты.
                    initPackets(piOnMainEnter);
                }
            }
        }
    }
};

TrapVirtualStdCall trMainFrame_setTitle;
TrapVirtualStdCall trMainFrame_setAddTitle;
funcdef void MainFrame_st(ITopLevelFrame&, const v8string&in);

void MainFrame_setTitle(ITopLevelFrame&frame, const v8string&in str)
{
    doLog("enter MainFrame_setTitle");
    setCaption(str, frame.getAdditionalTitle());
    doLog("exit MainFrame_setTitle");
}

void MainFrame_setAdditionalTitle(ITopLevelFrame&frame, const v8string&in str)
{
    doLog("enter MainFrame_setAdditionalTitle");
    setCaption(frame.getTitle(), str);
    doLog("exit MainFrame_setAdditionalTitle");
}

void setCaption(const v8string& title, const v8string& additionalTitle)
{
    v8string ibName;
    getProfileRoot().getString("CmdLine/IBName", ibName);
    if (ibName.isEmpty()) {
        ibName = "Unknown Base Name";
    }
    string caption = ibName.str + " / " + title.str.replace("Конфигуратор - ", "");
    string at = additionalTitle.str;
    if (!at.isEmpty())
        caption += " - " + at;
    IWindow&& wnd = cast<IUnknown>(mainFrame);
    if (wnd !is null)
        SetWindowText(wnd.hwnd(), caption.cstr);
}

// Класс-приемник информации о состоянии команды, для реализации ICommandState
class MyCommandState {
    CommandIDRef&& _id;
    int p;
    bool bEnable;
    bool bChecked;
    string text;
    string descr;
    string tooltip;

    MyCommandState()
    {
        p = 0;
        bEnable = bChecked = false;
    }
    uint id() { return _id.self;}
    int param(){return p;}
    uint object(uint i)
    {
        mem::dword[i] = 0;
        return i;
    }
    void enable(bool enable) { bEnable = enable; }
    void setCheck(bool check){ bChecked = check; }
    void setText(const v8string& str) { text = str; }
    void u1(uint u) {}
    void setDescription(const v8string& str) { descr = str; }
    void setTooltipText(const v8string& str) { tooltip = str; }
    void u2(uint u){}
    void t1(){}
    void t2(){}
    void t3(){}
    void t4(){}
    void t5(){}
};

// Флаги обработки состояния команды
enum stateFlags {
    cmdStateHandler = 1,    // имеется обработчик команды
    cmdStateEnabled = 2,    // команда доступна
    cmdStateChecked = 4,    // команда помечена
};

uint commandState(const CommandID& cmd)
{
    if (coreMainFrame !is null) {
        ICommandReceiver&& cmdReceiver = cast<IUnknown>(coreMainFrame);
        if (cmdReceiver !is null && cmdReceiver.hasHandler(cmd)) {
            MyCommandState st;
            &&st._id = cmd.ref();
            cmdReceiver.updateState(AStoIUnknown(&&st, IID_ICommandState));
            return cmdStateHandler | (!st.bEnable ? 0 : cmdStateEnabled) | (!st.bChecked ? 0 : cmdStateChecked);
        }
    }
    return 0;
}

void sendCommandToMainFrame(const CommandID& cmd)
{
    if (coreMainFrame !is null) {
        ICommandReceiver&& pCmdRcv = cast<IUnknown>(coreMainFrame);
        if (pCmdRcv !is null) {
            if (pCmdRcv.hasHandler(cmd))
                pCmdRcv.transmitCommand(Command(cmd, 0));
        }
    }
}

class IdleHandler {
    bool first = true;
    bool onIdle(int count)
    {
        if (first) {
            first = false;
            initPackets(piOnFirstIdle);
        }
        return false;
    }
    int unknown()
    {
        return idleHandlerUnknownFuncAnswer;
    }
};
